]> arthur.barton.de Git - backup-script.git/blobdiff - bin/backup-script
backup-audit: Exclude quota status files in / directory
[backup-script.git] / bin / backup-script
index 1099f0c73b2bc1d5d7b1b561d2f350d0e4499768..3d3db8512592bf45fd1217afd98b869c67717ead 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/bash
 #
 # backup-script system for cloning systems using rsync
-# Copyright (c)2008-2016 Alexander Barton <alex@barton.de>
+# Copyright (c)2008-2017 Alexander Barton <alex@barton.de>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,6 +15,8 @@ PIDFILE="/var/run/$NAME.pid"
 
 DRYRUN=0
 VERBOSE=0
+TAG=""
+PREPOSTEXEC=1
 
 export LC_ALL=C
 
@@ -22,6 +24,7 @@ declare -i count_all=0
 declare -i count_started=0
 declare -i count_ok=0
 declare -i count_ok_vanished=0
+declare -i count_enabled=0
 
 destinations=""
 
@@ -29,6 +32,7 @@ destinations=""
 [ -d "/usr/local/etc/backup-script.d" ] \
        && conf_d="/usr/local/etc/backup-script.d" \
        || conf_d="/etc/backup-script.d"
+setup_exec=""
 pre_exec=""
 post_exec=""
 default_backup_type="rsync"
@@ -44,28 +48,41 @@ default_compress=1
 default_ping=1
 default_local=0
 default_generations=0
+default_io_timeout="1800"
 default_job_pre_exec=""
 default_job_post_exec=""
+default_tags=""
+
+# Set shell options.
+shopt -s nullglob
 
 Usage() {
-       echo "Usage: $NAME [<options>] [<system> [<system> [...]]]"
-       echo
-       echo "  -p, --progress    Show progress, see rsync(1)."
-       echo "  -n, --dry-run     Test run only, don't copy any data."
-       echo
-       echo "When no <system> is given, all defined systems are used."
-       echo
-       echo -e $config_info
-       echo
+       {
+               echo "Usage: $NAME [<options>] [<job> [<job> [...]]]"
+               echo
+               echo "  -n, --dry-run       Test run only, don't copy any data."
+               echo "  -p, --progress      Show progress, see rsync(1)."
+               echo "  -t TAG, --tag TAG   Only run jobs with tag TAG."
+               echo "  -x, --no-exec       Don't run global pre-/post-exec commands."
+               echo
+               echo "When no <job> is given, all defined systems are used."
+               echo
+               # shellcheck disable=SC2086
+               echo -e $config_info
+               echo
+       } >&2
        exit 2
 }
 
+ErrorMsg () {
+       printf "%s\\n" "$@" >&2
+}
+
 CleanUp() {
-       if [ -n "$post_exec" ]; then
+       if [[ -n "$pre_exec" && $PREPOSTEXEC -ne 0 ]]; then
                echo "Executing \"$post_exec\" ..."
-               sh -c $post_exec
-               if [ $? -ne 0 ]; then
-                       echo "Warning: post-exec command failed!"
+               if ! sh -c $post_exec; then
+                       ErrorMsg "Warning: post-exec command failed!"
                fi
                echo
        fi
@@ -74,10 +91,10 @@ CleanUp() {
 
 GotSignal() {
        echo
-       echo "--> Got break signal, cleaning up & aborting ..."
+       ErrorMsg "--> Got signal, cleaning up & aborting ..."
        echo
        CleanUp
-       echo -n "Aborted: "; date
+       ErrorMsg "Aborted: $(date)" >&2
        echo
        sleep 3
        exit 9
@@ -90,7 +107,7 @@ ExecJob() {
        echo "Running job ${what}-exec command ..."
        [ "$local" -eq 0 ] \
                && cmd="$ssh_cmd ${user}@${system} $cmd"
-       echo -n "Start date (${what}-exec): "; date
+       echo "Start date (${what}-exec): $(date)"
        echo "$cmd"
        if [ "$DRYRUN" -eq 0 ]; then
                $SHELL -c "$cmd"; local ret=$?
@@ -98,9 +115,11 @@ ExecJob() {
                echo " *** Trial run, not executing ${what}-exec command!"
                ret=0
        fi
-       [ $ret -eq 0 ] \
-               && echo "The ${what}-exec command completed with status 0, OK." \
-               || echo "The ${what}-exec command completed with ERRORS, code $ret!"
+       if [ $ret -eq 0 ]; then
+               echo "The ${what}-exec command completed with status 0, OK."
+       else
+               ErrorMsg "The ${what}-exec command completed with ERRORS, code $ret!"
+       fi
        return $ret
 }
 
@@ -134,7 +153,7 @@ CreateSubvolume() {
                zfs create "$(echo "$volume" | cut -c2-)" || return 1
                ;;
          *)
-               echo "CreateSubvolume: Incompatible FS type \"$fs\" on \"$dir\"!"
+               ErrorMsg "CreateSubvolume: Incompatible FS type \"$fs\" on \"$dir\"!"
                return 9
        esac
        return 0
@@ -162,7 +181,7 @@ CloneSubvolume() {
                        "$(dirname "$volume")/$link_name"
                ;;
          *)
-               echo "CloneSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
+               ErrorMsg "CloneSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
                return 9
        esac
        return 0
@@ -185,7 +204,7 @@ RenameSubvolume() {
                        || return 1
                ;;
          *)
-               echo "RenameSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
+               ErrorMsg "RenameSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
                return 9
        esac
        return 0
@@ -213,7 +232,7 @@ DeleteSubvolume() {
                [ -h "$volume" ] && rm "$volume"
                ;;
          *)
-               echo "DeleteSubvolume: Incompatible FS type \"$fs\" on \"$volume\"!"
+               ErrorMsg "DeleteSubvolume: Incompatible FS type \"$fs\" on \"$volume\"!"
                return 9
        esac
        return 0
@@ -228,10 +247,11 @@ Initialize_Last_SysTarget_Snapshot() {
        case "$fs" in
          "btrfs")
                # Search directory of last generation, if any
+               # shellcheck disable=SC2012
                last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
                if [ -n "$last" ]; then
                        if [ ! -d "$last" ]; then
-                               echo "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
+                               ErrorMsg "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
                                echo
                                return 1
                        fi
@@ -259,7 +279,7 @@ Initialize_Last_SysTarget_Snapshot() {
                sys_target="$sys_target/current"
                ;;
          *)
-               echo "Initialize_Last_SysTarget_Snapshot: Incompatible FS type \"$fs\" on \"$sys_target\"!"
+               ErrorMsg "Initialize_Last_SysTarget_Snapshot: Incompatible FS type \"$fs\" on \"$sys_target\"!"
                return 1
        esac
        return 0
@@ -278,11 +298,12 @@ done
 # Read in configuration file
 config_info="Configuration file is \"$conf\""
 if [ -r "$conf" ]; then
+       # shellcheck source=/dev/null
        source "$conf"
 else
        config_info="${config_info} (not readable, using defaults)"
 fi
-config_info="${config_info},\nusing \"$conf_d\" as configuration directory."
+config_info="${config_info},\\nusing \"$conf_d\" as configuration directory."
 
 while [ $# -gt 0 ]; do
        case "$1" in
@@ -292,6 +313,13 @@ while [ $# -gt 0 ]; do
          "-p"|"--progress")
                VERBOSE=1; shift
                ;;
+         "-t"|"--tag")
+               shift; TAG="$1"; shift
+               [ -n "$TAG" ] || Usage
+               ;;
+         "-x"|"--no-exec")
+               PREPOSTEXEC=0; shift
+               ;;
          "-"*)
                Usage
                ;;
@@ -300,68 +328,77 @@ while [ $# -gt 0 ]; do
        esac
 done
 
-echo -n "Started: "; date
+echo "Started: $(date)"
 echo -e "$config_info"
 
 # Check rsync and its protocol version
-rsync=$(which "rsync" 2>/dev/null)
-if [ $? -ne 0 ]; then
-       echo "Failed to detect rsync(1)! Is it installed in your \$PATH?"
+if ! rsync=$(which "rsync" 2>/dev/null); then
+       ErrorMsg "Failed to detect rsync(1)! Is it installed in your \$PATH?"
        exit 1
 fi
-rsync_proto=$($rsync --version 2>/dev/null | head -n 1 | sed 's/.*  protocol version \([0-9]*\)$/\1/')
-if [ $? -ne 0 ]; then
-       echo "Failed to detect protocol version of $rsync!"
+if ! rsync_proto=$($rsync --version 2>/dev/null | head -n 1 | sed 's/.*  protocol version \([0-9]*\)$/\1/'); then
+       ErrorMsg "Failed to detect protocol version of $rsync!"
        exit 1
 fi
 echo "Rsync command is $rsync, protocol version $rsync_proto."
-echo
 
-trap GotSignal SIGINT
+[[ -n "$TAG" ]] && echo "Running jobs tagged with \"$TAG\"."
+echo
 
 if [ $# -ge 1 ]; then
        for s in "$@"; do
                if [ ! -r "${conf_d}/$s" ]; then
-                       echo "$NAME: Can' read \"${conf_d}/$s\"!"
+                       ErrorMsg "$NAME: Can' read \"${conf_d}/$s\"!"
                        exit 3
                fi
-               sys="$sys ${conf_d}/$s"
+               sys+=("${conf_d}/$s")
        done
 else
-       sys="${conf_d}/"*
+       sys=("${conf_d}/"*)
+fi
+
+if [[ -n "$setup_exec" && $PREPOSTEXEC -ne 0 ]]; then
+       echo "Executing \"$setup_exec\" ..."
+       if ! sh -c $setup_exec; then
+               ErrorMsg "Error: setup command failed!"; echo
+               ErrorMsg "Aborting backup."; echo
+               exit 5
+       fi
+       sleep 2
+       echo
 fi
 
+trap GotSignal SIGINT SIGTERM
+
 # check and create PID file
 if [ -e "$PIDFILE" ]; then
-       echo "Lockfile \"$PIDFILE\" already exists."
-       echo "Is an other instance still running?"
+       ErrorMsg "Lockfile \"$PIDFILE\" already exists."
+       ErrorMsg "Is an other instance still running?"
        echo
-       echo -n "Aborted: "; date
+       ErrorMsg "Aborted: $(date)" >&2
        echo
        exit 4
 fi
-touch "$PIDFILE" 2>/dev/null
-if [ $? -ne 0 ]; then
-       echo "Warning: can't create PID file \"$PIDFILE\"!"
+if ! touch "$PIDFILE" 2>/dev/null; then
+       ErrorMsg "Warning: can't create PID file \"$PIDFILE\"!"
        echo
 else
        echo "$$" >>"$PIDFILE"
 fi
 
-if [ -n "$pre_exec" ]; then
+if [[ -n "$pre_exec" && $PREPOSTEXEC -ne 0 ]]; then
        echo "Executing \"$pre_exec\" ..."
-       sh -c $pre_exec
-       if [ $? -ne 0 ]; then
-               echo "Error: pre-exec command failed!"; echo
+       if ! sh -c $pre_exec; then
+               ErrorMsg "Error: pre-exec command failed!"; echo
                CleanUp
-               echo "Aborting backup."; echo
+               ErrorMsg "Aborting backup."; echo
                exit 5
        fi
        sleep 2
        echo
 fi
 
-for f in $sys; do
+for f in "${sys[@]}"; do
        [[ -r "$f" && -f "$f" ]] || continue
 
        fname=$(basename "$f")
@@ -388,6 +425,8 @@ for f in $sys; do
        generations="$default_generations"
        job_pre_exec="$default_job_pre_exec"
        job_post_exec="$default_job_post_exec"
+       tags="$default_tags"
+       io_timeout="$default_io_timeout"
 
        # Compatibility with backup-pull(1) script: Save global values ...
        pre_exec_saved="$pre_exec"
@@ -400,6 +439,7 @@ for f in $sys; do
        unset post_exec
 
        # Read in system configuration file
+       # shellcheck source=/dev/null
        source "$f"
 
        # Compatibility with backup-pull(1) script: Fix up configuration
@@ -423,12 +463,27 @@ for f in $sys; do
                compress=0
        fi
 
-       # Make sure "source" ends with a slash ("/")
-       case "$source" in
-         "*/")
+       # Add "NONE" tag when no tags are given in the config file:
+       [[ -z "$tags" ]] && tags="NONE"
+       # Add "auto-tags":
+       [[ "$local" -eq 1 ]] && tags="$tags,LOCAL"
+       # Check tags
+       if [[ -n "$TAG" && "$TAG" != "ALL" ]]; then
+               if ! echo "$tags" | grep -E "(^|,)$TAG(,|$)" >/dev/null 2>&1; then
+                       if [ "$DRYRUN" -ne 0 ]; then
+                               echo "Tags of system \"$system\" don't match \"$TAG\": \"$tags\". Skipped."
+                               echo
+                       fi
+                       continue
+               fi
+       fi
+
+       # Make sure "source_root" ends with a slash ("/")
+       case "$source_root" in
+         *"/")
                ;;
-         "*")
-               source="$source/"
+         *)
+               source_root="$source_root/"
        esac
 
        # Make sure "target" DOESN'T end with a slash ("/")
@@ -447,13 +502,21 @@ for f in $sys; do
 
        count_all=$count_all+1
 
+       # Check if job is disabled
+       if [ "$backup_type" = "disabled" ]; then
+               echo "Job is DISABLED and will be skipped."
+               echo; continue
+       fi
+
+       count_enabled=$count_enabled+1
+
        # Check target directory
        if [ -z "$target" ]; then
-               echo "No target directory specified for \"$system\"!? Skipped!"
+               ErrorMsg "No target directory specified for \"$system\"!? Skipped!"
                echo; continue
        fi
        if [ ! -d "$target" ]; then
-               echo "Target \"$target\" is not a directory!? \"$system\" skipped!"
+               ErrorMsg "Target \"$target\" is not a directory!? \"$system\" skipped!"
                echo; continue
        fi
 
@@ -461,21 +524,20 @@ for f in $sys; do
        sys_root="$sys_target"
        if [[ "$DRYRUN" -eq 0 && ! -e "$sys_target" ]]; then
                if [ $generations -gt 0 ]; then
-                       CreateSubvolume "$sys_target"
+                       CreateSubvolume "$sys_target"; r=$?
                else
-                       mkdir -p "$sys_target"
+                       mkdir -p "$sys_target"; r=$?
                fi
-               if [ $? -ne 0 ]; then
-                       echo "Can't create \"$sys_target\"!? \"$system\" skipped!"
+               if [ $r -ne 0 ]; then
+                       ErrorMsg "Can't create \"$sys_target\"!? \"$system\" skipped!"
                        echo; continue
                fi
        fi
 
        if [[ "$local" -eq 0 && "$ping" -ne 0 ]]; then
                # Check if system is alive
-               ping -c 1 "$system" >/dev/null 2>&1
-               if [ $? -ne 0 ]; then
-                       echo "Host \"$system\" seems not to be alive!? Skipped."
+               if ! ping -c 1 "$system" >/dev/null 2>&1; then
+                       ErrorMsg "Host \"$system\" seems not to be alive!? Skipped."
                        echo; continue
                fi
                echo "OK, host \"$system\" seems to be alive."
@@ -486,7 +548,7 @@ for f in $sys; do
                if [ -e "$sys_target/.stamp" ]; then
                        # There seems to be a genearation-less backup in the
                        # target directory!
-                       echo "Target directory \"$sys_target\" seems to be unclean!? \"$system\" skipped!"
+                       ErrorMsg "Target directory \"$sys_target\" seems to be unclean!? \"$system\" skipped!"
                        echo; continue
                fi
 
@@ -495,10 +557,13 @@ for f in $sys; do
                if [[ -n "$last" && ! -e "$last/.stamp" ]]; then
                        # Old backup directory without "stamp file", continue
                        echo "Found incomplete snapshot in \"$last\", reusing and renaming it ..."
-                       RenameSubvolume "$last" "$sys_target"
-                       if [ $? -ne 0 ]; then
-                               echo "Failed to rename last snapshot \"$last\" to \"$sys_target\"!? \"$system\" skipped!"
-                               echo; continue
+                       if [ "$DRYRUN" -eq 0 ]; then
+                               if ! RenameSubvolume "$last" "$sys_target"; then
+                                       ErrorMsg "Failed to rename last snapshot \"$last\" to \"$sys_target\"!? \"$system\" skipped!"
+                                       echo; continue
+                               fi
+                       else
+                               echo " *** Trial run, not renaming snapshot \"$last\" to \"$sys_target\"!"
                        fi
                elif [ -n "$last" ]; then
                        # Old backup directory found, create new snapshot
@@ -506,7 +571,7 @@ for f in $sys; do
                        if [ "$DRYRUN" -eq 0 ]; then
                                CloneSubvolume "$last" "$sys_target" "$snapshot"; r=$?
                                if [ $r -ne 0 ]; then
-                                       echo "Can't create snapshot \"$snapshot\" of \"$last\", code $r!? \"$system\" skipped!"
+                                       ErrorMsg "Can't create snapshot \"$snapshot\" of \"$last\", code $r!? \"$system\" skipped!"
                                        echo; continue
                                fi
                                echo "Created new snapshot in \"$snapshot\"."
@@ -518,7 +583,7 @@ for f in $sys; do
                        if [ "$DRYRUN" -eq 0 ]; then
                                CreateSubvolume "$sys_target"; r=$?
                                if [ $r -ne 0 ]; then
-                                       echo "Can't create subvolume \"$sys_target\", code $r!? \"$system\" skipped!"
+                                       ErrorMsg "Can't create subvolume \"$sys_target\", code $r!? \"$system\" skipped!"
                                        echo; continue
                                fi
                                echo "Created new subvolume in \"$sys_target\"."
@@ -536,17 +601,17 @@ for f in $sys; do
                ExecJob pre "$job_pre_exec" ; ret=$?
                if [ $ret -ne 0 ]; then
                        [ $ret -ne 99 ] && count_started=$count_started+1
-                       echo "Pre-exec command failed, \"$system\" skipped!"
+                       ErrorMsg "Pre-exec command failed, \"$system\" skipped!"
                        echo; continue
                fi
        fi
 
        # prepare (remote) command ...
        if [[ "$backup_type" == "rsync" ]]; then
-               cmd="$rsync --archive"
+               cmd="$rsync --archive --timeout=$io_timeout"
                [ "$compress" -ne 0 ] && cmd="$cmd --compress"
                [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
-               cmd="$cmd --delete --delete-excluded --sparse"
+               cmd="$cmd --delete-during --delete-excluded --sparse"
                if [ "$VERBOSE" -gt 0 ]; then
                        [ "$rsync_proto" -ge 31 ] \
                                && cmd="$cmd --info=progress2" \
@@ -581,18 +646,22 @@ for f in $sys; do
                        && cmd="$cmd ${user}@${system}:$source_root $sys_target/" \
                        || cmd="$cmd $source_root $sys_target/"
        elif [[ "$backup_type" == "scp" ]]; then
-               cmd="scp"
+               # scp writes some warning messages to stderr (like "Connection
+               # to ... closed by remote host."), even when there is no error
+               # and the exit code is 0 ("no error"); therefore we redirect
+               # stderr to stdout to not confuse "mail wrapper scripts" etc.
+               cmd="scp 2>&1"
                [ "$VERBOSE" -eq 0 ] && cmd="$cmd -q"
                for file in $files; do
                        cmd="$cmd ${user}@${system}:$file $sys_target/"
                done
        else
-               echo "Backup type \"$backup_type\" undefined, \"$system\" skipped!"
+               ErrorMsg "Backup type \"$backup_type\" undefined, \"$system\" skipped!"
                echo; continue
        fi
 
        echo "Backing up to \"$sys_target\" ..."
-       echo -n "Start date: "; date
+       echo "Start date: $(date)"
        echo "$cmd"
        count_started=$count_started+1
        ok=0
@@ -606,23 +675,25 @@ for f in $sys; do
                $SHELL -c "$cmd"; ret=$?
                end_t=$(date "+%s")
 
-               echo "code=$ret" >"$stamp_file"
-               echo "start_t=$start_t" >>"$stamp_file"
-               echo "end_t=$end_t" >>"$stamp_file"
-               echo "cmd='$cmd'" >>"$stamp_file"
-               echo "backup_host='`hostname -f`'" >>"$stamp_file"
-               echo "backup_user='`id -un`'" >>"$stamp_file"
+               {
+                       echo "code=$ret"
+                       echo "start_t=$start_t"
+                       echo "end_t=$end_t"
+                       echo "cmd='$cmd'"
+                       echo "backup_host='$(hostname -f)'"
+                       echo "backup_user='$(id -un)'"
+               } >"$stamp_file"
        else
                echo " *** Trial run, not executing save command!"
                ret=0
        fi
 
        if [ $ret -eq 20 ]; then
-               echo "Backup of \"$system\" interrupted. Aborting ..."
+               ErrorMsg "Backup of \"$system\" interrupted. Aborting ..."
                GotSignal
        fi
 
-       echo -n "End date: "; date
+       echo "End date: $(date)"
        if [[ $ret -eq 0 || $ret -eq 24 ]]; then
                [ $ret -eq 24 ] && count_ok_vanished=$count_ok_vanished+1
 
@@ -630,7 +701,7 @@ for f in $sys; do
                [ "$DRYRUN" -gt 0 ] || count_ok=$count_ok+1
                ok=1
        else
-               echo "System \"$system\" completed with ERRORS, code $ret!"
+               ErrorMsg "System \"$system\" completed with ERRORS, code $ret!"
        fi
 
        # execute job "post-exec" command, if any
@@ -646,6 +717,7 @@ for f in $sys; do
                fi
                # Clean up old generations
                declare -i gen_count=$generations+2
+               # shellcheck disable=SC2012
                to_delete=$(ls -1t "$sys_root" 2>/dev/null | tail -n+$gen_count | sort)
                if [[ -n "$to_delete" && $ok -eq 1 ]]; then
                        [ "$DRYRUN" -eq 0 ] \
@@ -654,21 +726,21 @@ for f in $sys; do
                        for delete in $to_delete; do
                                dir="$sys_root/$delete"
                                if [ ! -e "$dir/.stamp" ]; then
-                                       echo "Not deleting \"$dir\", not a backup directory!?"
+                                       ErrorMsg "Not deleting \"$dir\" of \"$system\", not a backup directory!?"
                                        continue
                                fi
                                last=$(stat "$dir/.stamp" 2>/dev/null | grep "^Modify: " \
                                 | cut -d':' -f2- | cut -d. -f1)
+                               # shellcheck disable=SC2086
                                echo "Removing backup from" $last "..."
                                if [ "$DRYRUN" -eq 0 ]; then
-                                       DeleteSubvolume "$dir"
-                                       [ $? -eq 0 ] || \
-                                         echo "Failed to delete \"$dir\"!"
+                                       DeleteSubvolume "$dir" \
+                                               || ErrorMsg "Failed to delete \"$dir\" of \"$system\"!"
                                fi
                        done
-                       echo -n "Clean up finished: "; date
+                       echo "Clean up finished: $(date)"
                elif [ -n "$to_delete" ]; then
-                       echo "There have been errors, not cleaning up old generations!"
+                       ErrorMsg "There have been errors for \"$system\", not cleaning up old generations!"
                else
                        echo "Nothing to clean up (keep up to $generations generations)."
                fi
@@ -683,6 +755,7 @@ sync
 if [ "$DRYRUN" -eq 0 ]; then
        paths=""
        paths_zfs=""
+       # shellcheck disable=SC2086
        for dest in $(echo $destinations | sed -e 's/ /\n/g' | sort | uniq); do
                fs=$(GetFS "$dest")
                case $fs in
@@ -694,10 +767,12 @@ if [ "$DRYRUN" -eq 0 ]; then
                esac
        done
        if [ -n "$paths" ]; then
+               # shellcheck disable=SC2086
                df -h $paths
                echo
        fi
        if [ -n "$paths_zfs" ]; then
+               # shellcheck disable=SC2086
                zfs list $paths_zfs
                echo
        fi
@@ -705,10 +780,12 @@ fi
 
 CleanUp
 
-echo -n "Done: "; date
+echo "Done: $(date)"
 echo
 [ $count_all -eq 1 ] && s="" || s="s"
-echo " - $count_all job$s defined,"
+[ $count_enabled -eq $count_all ] \
+       && echo " - $count_all job$s defined (all enabled)," \
+       || echo " - $count_all job$s defined ($count_enabled enabled),"
 [ $count_started -eq 1 ] && s="" || s="s"
 echo " - $count_started job$s started,"
 echo " - $count_ok done without errors."
@@ -718,7 +795,7 @@ if [ $count_started -ne $count_ok ]; then
        echo "----->  THERE HAVE BEEN ERRORS!  <-----"
        echo
        exit 6
-elif [ $count_all -ne $count_started ]; then
+elif [ $count_enabled -ne $count_started ]; then
        exit 7
 fi